package at.ac.uibk.gitsearch.web.rest;

import at.ac.uibk.gitsearch.es.model.DocumentInfo;
import at.ac.uibk.gitsearch.repository.search.GitFilesRepository;
import at.ac.uibk.gitsearch.service.SearchService;
import at.ac.uibk.gitsearch.service.dto.GitFilesAggregationDTO;
import at.ac.uibk.gitsearch.service.dto.GitFilesPageDetailsDTO;
import at.ac.uibk.gitsearch.service.dto.SearchInputDTO;
import at.ac.uibk.gitsearch.service.dto.SearchResultsDTO;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.io.IOException;
import java.util.List;

import javax.persistence.PostPersist;

/**
 * REST controller for managing {@link DocumentInfo}.
 */
@RestController
@RequestMapping("/api")
@Transactional
public class SearchResource {

    private final Logger log = LoggerFactory.getLogger(SearchResource.class);

    private final SearchService searchService;

    public SearchResource(SearchService searchService) {
        this.searchService = searchService;
    }

    /**
      * {@code SEARCH  /search/page-details} : search for the searchResults corresponding
     *  to the query.
     *
	 * @param query the query of the searchResult search.
	 * @return the result of the search.
     */
    @PostMapping("/search/page-details")
    public SearchResultsDTO
    gitFilesPageDetails(@RequestBody SearchInputDTO query) throws IOException {
        log.debug("REST request to search  {}, pageSize {}", query);
        // return searchResultSearchRepository.findByContent(query);
        return searchService.searchResultPage(query,0, 10);
    }

}
